# -*- cpy-indent-level: 4; indent-tabs-mode: nil -*-
# ex: set expandtab softtabstop=4 shiftwidth=4:
#
# Copyright (C) 2008,2009,2010,2011,2012,2013,2014,2015  Contributor
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

from sqlalchemy import Column, ForeignKey
from sqlalchemy.orm import relation

from aquilon.aqdb.model import Resource, Grn

_TN = 'application'


class Application(Resource):
    """ Application resources """
    __tablename__ = _TN

    id = Column(ForeignKey(Resource.id, ondelete='CASCADE'),
                primary_key=True)

    eon_id = Column(ForeignKey(Grn.eon_id), nullable=False)

    grn = relation(Grn, innerjoin=True)

    __mapper_args__ = {'polymorphic_identity': _TN}
    __table_args__ = ({'info': {'unique_fields': ['name', 'holder']}},)
