CREATE TABLE USERINFO
(  ID integer CONSTRAINT USERINFO_ID_NN NOT NULL,
   NAME VARCHAR2(32) CONSTRAINT USERINFO_NAME_NN NOT NULL,
   "uid" integer CONSTRAINT USERINFO_uid_NN NOT NULL,
   GID integer CONSTRAINT USERINFO_GID_NN NOT NULL,
   FULL_NAME VARCHAR2(64) CONSTRAINT USERINFO_FULL_NAME_NN NOT NULL,
   HOME_DIR VARCHAR2(64) CONSTRAINT USERINFO_HOME_DIR_NN NOT NULL,
   CREATION_DATE DATE CONSTRAINT USERINFO_CR_DATE_NN NOT NULL,
   CONSTRAINT USERINFO_PK PRIMARY KEY (ID),
   CONSTRAINT USERINFO_USER_UK UNIQUE (NAME)
);

CREATE TABLE NETGROUP_WHITELIST
(  ID integer CONSTRAINT NETGROUP_WHITELIST_ID_NN NOT NULL,
   NAME VARCHAR2(64) CONSTRAINT NETGROUP_WHITELIST_NAME_NN NOT NULL,
   CONSTRAINT NETGROUP_WHITELIST_PK PRIMARY KEY (ID),
   CONSTRAINT NETGROUP_WHITELIST_UK UNIQUE (NAME)
);

CREATE TABLE PERSONALITY_ROOTUSER
(  PERSONALITY_ID integer CONSTRAINT PERS_ROOT_USER_PRSNLTY_ID_NN NOT NULL,
   USER_ID integer CONSTRAINT PERS_ROOT_USER_USER_ID_NN NOT NULL,
   CREATION_DATE DATE CONSTRAINT PERS_ROOT_USER_CR_DATE_NN NOT NULL,
   CONSTRAINT PERSONALITY_ROOTUSER_PK PRIMARY KEY (PERSONALITY_ID, USER_ID),
   CONSTRAINT PERS_ROOTUSER_PERS_FK FOREIGN KEY (PERSONALITY_ID) REFERENCES PERSONALITY (ID) ON DELETE CASCADE,
   CONSTRAINT PERS_ROOTUSER_USER_FK FOREIGN KEY (USER_ID) REFERENCES USERINFO (ID) ON DELETE CASCADE
);

CREATE TABLE PERSONALITY_ROOTNETGROUP
(  PERSONALITY_ID integer CONSTRAINT PERS_ROOT_NG_PRSNLTY_ID_NN NOT NULL,
   NETGROUP_ID integer CONSTRAINT PERS_ROOT_NG_NETGROUP_ID_NN NOT NULL,
   CREATION_DATE DATE CONSTRAINT PERS_ROOT_NG_CR_DATE_NN NOT NULL,
   CONSTRAINT PERSONALITY_ROOTNETGROUP_PK PRIMARY KEY (PERSONALITY_ID, NETGROUP_ID),
   CONSTRAINT PERS_ROOTNG_PERS_FK FOREIGN KEY (PERSONALITY_ID) REFERENCES PERSONALITY (ID) ON DELETE CASCADE ,
   CONSTRAINT PERS_ROOTNG_GROUP_FK FOREIGN KEY (NETGROUP_ID) REFERENCES NETGROUP_WHITELIST (ID) ON DELETE CASCADE
);

CREATE SEQUENCE USERINFO_ID_SEQ;
CREATE SEQUENCE NETGROUP_WHITELIST_ID_SEQ;

QUIT;
